#include "stdafx.h"
#include "Crate.h"

using namespace Ogre;

int Crate::instanceCount = 0;

Crate::Crate(SceneManager* sm, float x, float y, float z)
{
	health = healthMax = 70;
	radius = 13.5f;
	char name[20];
	sprintf(name, "crate_%04d", Crate::instanceCount++);
	SceneNode* rootNode = sm->getRootSceneNode();
	crate = sm->createEntity(name, "doboz.mesh");
	crate->setCastShadows(true);
		
	crateNode = rootNode->createChildSceneNode();
	crateNode->attachObject(crate);
	crateNode->scale(15, 15, 15);
	//crateNode->scale(0.2f, 0.2f, 0.2f);
	crateNode->translate(x, y, z);
}

float Crate::reduceHealth(float dist)
{ 
	float ret = 0;
	if (health > 0) ret = radius - dist;
	health -= radius - dist; 
	if (health < 0) perish();
	else if (health < healthMax / 2) halfPerish();
	return ret;
}

void Crate::halfPerish()
{
	crate->setMaterialName("doboz_cracked");
}

void Crate::perish()
{
	crate->setMaterialName("doboz_burning");
}

Crate::~Crate(void)
{
}