#include "stdafx.h"
#include "Hud.h"

Hud::Hud()
{
	Ogre::Overlay* mainOverlay= Ogre::OverlayManager::getSingleton().getByName("MainOverlay");
	mainOverlay->show();
	Ogre::OverlayElement* endText= Ogre::OverlayManager::getSingleton().getOverlayElement("EndGame0");
	endText->hide();
	Ogre::OverlayElement* endScore= Ogre::OverlayManager::getSingleton().getOverlayElement("EndGame1");
	endScore->hide();
	showCrosshair = false;
	timeFromSecond= 0;
	framesInSecond= 0;
	fps = 0;
	magazine = 30;
	ammo = 300;
	hits = 0;
}

void Hud::reloadMagazine()
{
	ammo -= 30-magazine;
	if (ammo < 0) 
	{
		magazine = 30 + ammo;
		ammo = 0;
	}
	else magazine = 30;
}

void Hud::endGame()
{
	Ogre::OverlayElement* endScore= Ogre::OverlayManager::getSingleton().getOverlayElement("EndGame0");
	endScore->setCaption(Ogre::StringConverter::toString(hits,4));	
	endScore->show();
	Ogre::OverlayElement* endText= Ogre::OverlayManager::getSingleton().getOverlayElement("EndGame1");
	endText->show();

}

void Hud::update(float t, float dt)
{
	if (ammo <= 0 && magazine <= 0) endGame();
	timeFromSecond+= dt;
	framesInSecond++;
	if(timeFromSecond>= 1)
	{
		fps = framesInSecond / timeFromSecond;
		timeFromSecond= 0;
		framesInSecond= 0;
	}
	//update fps
	Ogre::OverlayElement* fpsText= Ogre::OverlayManager::getSingleton().getOverlayElement("FPS");
	fpsText->setCaption(Ogre::StringConverter::toString(fps,4));

	//update healts, bullets
	Ogre::OverlayElement* hitsText= Ogre::OverlayManager::getSingleton().getOverlayElement("Hits");
	hitsText->setCaption( Ogre::StringConverter::toString(hits,4) );
	Ogre::OverlayElement* magCountText= Ogre::OverlayManager::getSingleton().getOverlayElement("Magazine");
	magCountText->setCaption( Ogre::StringConverter::toString(magazine) );
	Ogre::OverlayElement* ammoText= Ogre::OverlayManager::getSingleton().getOverlayElement("Ammo");
	ammoText->setCaption( Ogre::StringConverter::toString(ammo) );

	Ogre::OverlayElement* crosshair= Ogre::OverlayManager::getSingleton().getOverlayElement("Cross");
	if (showCrosshair) crosshair->show();
	else crosshair->hide();
	
	if (showMagazineCounter) magCountText->show();
	else magCountText->hide();
}



