#pragma once
#define OIS_DYNAMIC_LIB
#include <OIS/OIS.h>
#include "Ogre.h"
#include "PlayerController.h"

class InputHandler : public OIS::KeyListener, OIS::MouseListener
{
protected:
	OIS::InputManager* OISInputManager;
	OIS::Keyboard* mKeyboard;
	OIS::Mouse* mMouse;
	float mTimeUntilNextToggle;
	PlayerController* playerController;
	//HudController* hudController

public:
	InputHandler(Ogre::RenderWindow* renderWindow);
	~InputHandler(void);
	bool update(float t, float dt);
	void setPlayerController(PlayerController* c);
	
	bool keyPressed(const OIS::KeyEvent &keyEventRef);
	bool keyReleased(const OIS::KeyEvent &keyEventRef);

	bool mouseMoved(const OIS::MouseEvent &evt);
	bool mousePressed(const OIS::MouseEvent &evt, OIS::MouseButtonID id); 
	bool mouseReleased(const OIS::MouseEvent &evt, OIS::MouseButtonID id);
};
