#pragma once
#include "Ogre.h"
//#include "Hud.h"

class Hud;
class Level;

class PlayerCharacter
{
public:
	PlayerCharacter(Ogre::SceneManager* sm, Hud* h, Level* lv);
	~PlayerCharacter(void);
	void update(float t, float dt);
	//static void updateAll();
	
	//Ogre::Vector3 getDirection(){return node->getOrientation() * Ogre::Vector3::UNIT_Z;}
	Ogre::Vector3 getPosition(){return node->getPosition();}
	void move(float amount);
	//void turnHorizontal(float amount);
	//void turnVertical(float amount);
	void shoot(bool);
	bool takeAim(bool);
	void reload();
	bool hitQuery();

	bool inAction();

	Ogre::Vector3 getLookDirection() { return lookDir; }
	void setLookDirection(const Ogre::Vector3& dir) { lookDir = dir.normalisedCopy(); }
	void setRayOrigin(const Ogre::Vector3& v) { rayOrigin = v; }
	//void setParentNode(Ogre::SceneNode* parent); 
	void setTruckNode(Ogre::SceneNode* tr) {truckNode = tr;}
	void setFollowTruck(bool);

protected:
	Ogre::Vector3 lookDir;
	Ogre::Vector3 rayOrigin;

	enum PlayerAction { PA_BASE, PA_WEAPON_HOLD, PA_SHOOT, PA_RELOAD };
	enum ShootState { SH_TAKE_AIM, SH_AIM, SH_SHOOT, SH_END_AIM, SH_RELOAD };
	enum PlayerPose { PP_BASE, PP_STAND, PP_RUN };
	PlayerAction action;
	PlayerAction lastAction;
	PlayerPose pose;
	PlayerPose lastPose;
	ShootState shootState;
	//ShootState lastShootState;
	
	Ogre::Entity* entity;
	Ogre::SceneNode* node;
	Ogre::SceneNode* truckNode;
	Ogre::AnimationState* actionAnim;
	Ogre::AnimationState* poseAnim;
	
	Ogre::RaySceneQuery* raySceneQuery;

	bool followTruck;
//	bool hasWeapon;
	Ogre::SceneNode* weaponNode;
	Hud* hud;
	Level* level;
};
