#pragma once
#include "PlayerCharacter.h"
#include "ThirdPersonCamera.h"
#include "Hud.h"
#define OIS_DYNAMIC_LIB
#include <OIS/OIS.h>

class PlayerController
{
public:
	PlayerController(PlayerCharacter* c, ThirdPersonCamera* cam, Hud* h);
	~PlayerController(void);

	void update(float t, float dt, OIS::Keyboard* keyboard, OIS::Mouse* mouse);
	bool keyPressed(const OIS::KeyEvent &keyEventRef);
	bool mouseMoved(const OIS::MouseEvent &evt);
	bool mousePressed(const OIS::MouseEvent &evt, OIS::MouseButtonID id);
	bool mouseReleased(const OIS::MouseEvent &evt, OIS::MouseButtonID id);
	
protected:	
	float mTimeUntilNextToggle;
	PlayerCharacter* character;
	ThirdPersonCamera* camera;
	Hud* hud;
};
