#include "stdafx.h"
#include "Target.h"

using namespace Ogre;

int Target::instanceCount = 0;

Target::Target(SceneManager* sm, float x, float y, float z)
{
	health = healthMax = 150;
	radius = 13.5f;
	char name[20];
	sprintf(name, "target_%04d", Target::instanceCount++);
	SceneNode* rootNode = sm->getRootSceneNode();
	target = sm->createEntity(name, "target01.mesh");
	target->setCastShadows(true);
		
	targetNode = rootNode->createChildSceneNode();
	targetNode->attachObject(target);
	targetNode->scale(3, 40, 20);
	//targetNode->scale(0.2f, 0.2f, 0.2f);
	targetNode->translate(x, y, z);
}

float Target::reduceHealth(float dist)
{ 
	float ret = 0;
	if (health > 0) ret = radius - dist;
	health -= radius - dist; 
	if (health < 0) perish();
	else if (health < healthMax / 2) halfPerish();
	return ret;
}

void Target::halfPerish()
{
	target->getSubEntity(1)->setMaterialName("target_cracked");
}

void Target::perish()
{
	target->getSubEntity(1)->setMaterialName("target_perish");
}

Target::~Target(void)
{
}