#include "stdafx.h"
#include "Truck.h"

using namespace Ogre;

Truck::Truck(SceneManager* sm)
{
	time = 0;
	SceneNode* rootNode = sm->getRootSceneNode();
	truckNode = rootNode->createChildSceneNode();
	Entity* truck = sm->createEntity("truck", "truck.mesh");
	truck->setCastShadows(false);

	truckNode->attachObject(truck);
	truckNode->scale(0.15f, 0.15f, 0.15f);
	truckNode->translate(0, 12, 30);

	Plane plane(Vector3::UNIT_Y, 0);
	MeshManager::getSingleton().createPlane("deck",ResourceGroupManager::DEFAULT_RESOURCE_GROUP_NAME, plane,
			                                100,240,1,1,true,1,1,1,Vector3::UNIT_Z);

	Entity* deckEntity = sm->createEntity("deckEntity", "deck");
    deckNode = truckNode->createChildSceneNode();
	deckNode->attachObject(deckEntity);
	deckNode->translate(0, 0, 110);
    deckEntity->setMaterialName("Deck");
    deckEntity->setCastShadows(true);
}

Truck::~Truck(void)
{
}

void Truck::update(float t, float dt)
{
	//float atime = startTime - time;
	time += dt;

	const float speed = 0.05f;

	float phi = time * speed;
	float x = cos(phi);
	float z = sin(phi);

	const float scaleX = 2500;
	const float scaleZ = 500;
	
	truckNode->setPosition(x * scaleX, 12, z * scaleZ);
	
	truckNode->resetOrientation();
	const float halfPi = 3.141592 / 2;
	float x1 = cos(phi + halfPi);
	float z1 = sin(phi + halfPi);
	Vector3 left(-z1,0,x1);
	Vector3 dir(left.x / scaleX, 0, left.z / scaleZ);
	const Quaternion quat( Radian(-halfPi), Vector3::UNIT_Y);

	truckNode->setDirection( quat * dir );
}















